node {
  try {
    def ADB="$ANDROID_HOME/platform-tools/adb"
    def EMULATOR = "$ANDROID_HOME/tools/emulator"
    def EMULATOR_NAME= "test"
  
    stage ('Stage Checkout') {
      checkout scm
    }
    
    stage ('Stage Build') {
      sh "./gradlew clean assembleDebug"
    }

    stage ('Stage Unit Tests') {
      sh "./gradlew testDebugUnitTest"
    }

    stage ('Stage UI Tests') {
      sh "$ADB start-server"

      def error
      parallel (
        lauchEmulator: {
          sh "$ANDROID_HOME/tools/bin/avdmanager - list avd"
          sh "$EMULATOR -avd $EMULATOR_NAME -netdelay none -netspeed full"
        },
        runAndroidTests: {
          timeout(time: 20, unit: 'SECONDS') {
            sh "$ADB wait-for-device"
          }
          try {
              sh "./gradlew :app:connectedAndroidTest"
          } catch(e) {
              error = e
          }
          sh "adb -s $EMULATOR_NAME emu kill"
        }
      )
    }
  } catch (e) {
    currentBuild.result = "FAILED"
    throw e
  } finally {
    stage('Stage Clean') {
       // sh script: '/var/lib/jenkins/clean.sh'
    }
  }
}